(use nanomsg test)

(test "protocol" 'bus    (nn-socket-protocol (nn-socket 'bus)))
(test "protocol" 'req    (nn-socket-protocol (nn-socket 'req)))
(test "domain"   'sp     (nn-socket-domain   (nn-socket 'bus)))
(test "domain"   'sp-raw (nn-socket-domain   (nn-socket 'pair 'sp-raw)))

(define s  (nn-socket 'bus))

(set! (nn-socket-name s)           "foo")
(set! (nn-socket-linger s)             1)
(set! (nn-socket-sndbuf s)             2)
(set! (nn-socket-rcvbuf s)             3)
(set! (nn-socket-sndtimeo s)           4)
(set! (nn-socket-rcvtimeo s)           5)
(set! (nn-socket-reconnect-ivl s)      6)
(set! (nn-socket-reconnect-ivl-max s)  7)
(set! (nn-socket-sndprio s)            8)
(set! (nn-socket-rcvprio s)            9)
(set! (nn-socket-rcvmaxsize s)        11)
(set! (nn-socket-maxttl s)            12)

(test "NN_SOCKET_NAME"    "foo" (nn-socket-name s))
(test "NN_SNDFD"             #t (fixnum? (nn-socket-sndfd s)))
(test "NN_RCVFD"             #t (fixnum? (nn-socket-rcvfd s)))
(test "NN_LINGER"             1 (nn-socket-linger s))
(test "NN_SNDBUF"             2 (nn-socket-sndbuf s))
(test "NN_RCVBUF"             3 (nn-socket-rcvbuf s))
(test "NN_SNDTIMEO"           4 (nn-socket-sndtimeo s))
(test "NN_RCVTIMEO"           5 (nn-socket-rcvtimeo s))
(test "NN_RECONNECT_IVL"      6 (nn-socket-reconnect-ivl s))
(test "NN_RECONNECT_IVL_MAX"  7 (nn-socket-reconnect-ivl-max s))
(test "NN_SNDPRIO"            8 (nn-socket-sndprio s))
(test "NN_RCVPRIO"            9 (nn-socket-rcvprio s))
(test "NN_RCVMAXSIZE"        11 (nn-socket-rcvmaxsize s))
(test "NN_MAXTTL"            12 (nn-socket-maxttl s))

(set! (nn-socket-ipv4only s) 0)
(test "NN_IPV4ONLY off" 0 (nn-socket-ipv4only s))
(set! (nn-socket-ipv4only s) 1)
(test "NN_IPV4ONLY  on" 1 (nn-socket-ipv4only s))
